#include <iostream>
#include <vector>
#include <stack>
#include <string>

#ifndef CALC
#define CALC

class Calc
{
public:
	Calc()
		: VIEW_MSG(true)
		, code('0')
		, lastResult(0.0)
		, errorMsg("")
	{

	}
	~Calc()
	{
	}

	//  Էϸ  Ѵ.
	//  ϸ false ϰ errorMsg ޽   ִ.
	//  ϸ true ϰ lastResult     ִ.
	bool calcurator(std::string input)
	{
		std::string str = input; // ӽ 
		str = trim(str); // 

		str = changeMinusBeforeBracket(str); // ȣտ - ڰ  ͵ Ѵ.

		if (checkDoubleSign(str) == false)
		{
			errorMsg = "߸ Դϴ. (ڰ  ֽϴ.)";
			code = '1';
			return false;
		}

		if (checkEndSign(str) == false)
		{
			errorMsg = "߸ Դϴ. (  ڰ ֽϴ.)";
			code = '2';
			return false;
		}

		if (CheckBracket(str) == false)
		{
			errorMsg = "߸ Դϴ. ( ȣ   ʰų   ֽϴ.)";
			code = '3';
			return false;
		}

		if (checkCharacter(str) == false)
		{
			errorMsg = "߸ Դϴ. (Ŀ ڰ Ե  ϴ.)";
			code = '4';
			return false;
		}

		/*
		if (checkDivideZero(str) == false)
		{
			errorMsg = "߸ Դϴ. ( 0   ϴ.)";
			code = '5';
			return false;
		}
		*/

		std::vector<std::string> temp = parseString(str); // Ϳ    ڵ string ְ ȴ.

		std::vector<std::string>::iterator temp_itr2;

		if (VIEW_MSG)
		{
			std::cout << " ڿ :: ";
			for (temp_itr2 = temp.begin(); temp_itr2 != temp.end(); temp_itr2++)
			{
				std::cout << *temp_itr2 << ",";
			}
			std::cout << std::endl;
		}

		std::vector<std::string> result;
		std::vector<std::string> oper;

		std::vector<std::string>::iterator itr;
		for (itr = temp.begin(); itr != temp.end(); itr++)
		{
			if (*itr == "(")
			{
				oper.push_back(*itr);
			}
			else if (*itr == ")")
			{
				if (VIEW_MSG)
				{
					std::cout << "oper.size() :: " << oper.size() << std::endl;
					std::cout << "oper.at(oper.size() - 1) :: " << oper.at(oper.size() - 1) << std::endl;
				}

				while (oper.at(oper.size() - 1) != "(")
				{
					result.push_back(oper.at(oper.size() - 1));
					oper.pop_back();
				}

				if (VIEW_MSG)
				{
					std::cout << "oper.size() :: " << oper.size() << std::endl;
					std::cout << " ۵ǳ?" << std::endl;
				}
			
				if (!oper.empty())
				{
					if (VIEW_MSG)
					{
						std::cout << "( ϱ  pop_back oper.size() :: " << oper.size() << std::endl;
					}
					oper.pop_back();
				}
			}
			else if (*itr == "+" || *itr == "-" || *itr == "*" || *itr == "/")
			{	
				while (!oper.empty() && precedence(oper.at(oper.size() - 1)) >= precedence(*itr))
				{
					result.push_back(oper.at(oper.size() - 1));
					oper.pop_back();
				}
				oper.push_back(*itr);
			}
			else //  
			{
				//   ڰ 0̰ ̹  ִ ڰ / 0(n/0) ڴٴ ǹ̹Ƿ  
				if (std::stod(*itr) == 0.0 && oper.at(oper.size() - 1) == "/" && !oper.empty())
				{
					errorMsg = "߸ Դϴ. ( 0   ϴ.)";
					code = '5';
					return false;
				}

				//   ڰ /̰ ̹  ִ  0̶ 0 ڴٴ ǹ (0/n)
				// 0 n    ̸,
				// 0 ƴ  ̻  x   0  ȴ.
				/*
				else if (oper.at(oper.size() - 1) == "/" && std::stod(result.at(result.size() - 1)) == 0.0)
				{
					std::cout << "0/ " << std::endl;
					// errorMsg = "߸ ̰ų 꿡  ֽϴ. (0 0   ϴ.)";
					// code = '6';
					// return false;
					//result.pop_back();
					//oper.pop_back();
				}
				*/
				else
				{
					result.push_back(*itr);
				}
			}
		
			print(result, oper);
		}

		while (!oper.empty())
		{
			if (oper.at(oper.size() - 1) == "+" || oper.at(oper.size() - 1) == "-" || oper.at(oper.size() - 1) == "*" || oper.at(oper.size() - 1) == "/")
			{
				result.push_back(oper.at(oper.size() - 1));
			}
			oper.pop_back();
		}

		print(result, oper);

		std::vector<std::string>::iterator temp_itr;

		if (VIEW_MSG)
		{
			std::cout << " :: ";
			for (temp_itr = result.begin(); temp_itr != result.end(); temp_itr++)
			{
				std::cout << *temp_itr << ", ";
			}
			std::cout<< std::endl;
		}

		lastResult = GetLastResult(result);

		if (VIEW_MSG)
		{
			std::cout << "Է¼ :: " << input.c_str() << std::endl;
			std::cout << " :: " << lastResult << std::endl;
		}
		
		code = '0';
		return true;
	}

	//   Ѵ.
	double get_lastResult()
	{
		return lastResult;
	}

	char get_lastCode()
	{
		return code;
	}

	void init()
	{
		lastResult = 0.0;
		errorMsg = "";
		code = '0';
	}
protected:
private:
	const bool VIEW_MSG; // α׷ֽ ޽    
	double lastResult; //  
	std::string errorMsg; //   ޽
	char code; // Ŭ̾Ʈ    ڵ (̶ 0, ƴ϶  ̻ )
private:
	//  켱 ǴѴ.
	int precedence(std::string op)
	{
		if (op == "(")
		{
			return 0;
		}
		else if (op == "+" || op == "-")
		{
			return 1;
		}
		else if (op == "*" || op == "/")
		{
			return 2;
		}
		else
		{
			return 3;
		}
	}

	// ڿ ĭ  Ѵ. (ex : 2 -3+ 4 Ŀ  )
	std::string trim(std::string str)
	{
		std::string temp = "";
		std::string::iterator itr;
		for (itr = str.begin(); itr != str.end(); itr++)
		{
			if (*itr != ' ')
			{
				//std::cout << *itr << std::endl;
				temp += *itr;
			}
		}
		return temp;
	}

	// ȣ    ã´. (ex : 2-2+*3 ߸ )
	bool checkDoubleSign(std::string str)
	{
		char prev = NULL;
		char now = NULL;

		std::string::iterator itr;
		for (itr = str.begin(); itr != str.end(); itr++)
		{
			now = static_cast<char>(*itr);
			
			//std::cout << "prev :: " << prev << " - next :: " << now << std::endl;

			if ((now == '+' || now == '-' || now == '*' || now == '/') &&
				(prev == '+' || prev == '-' || prev == '*' || prev == '/'))
			{
				return false;
			}

			prev = now;
		}

		return true;
	}

	// 0   ˻Ѵ. (ex : 3/0 ߸ )
	bool checkDivideZero(std::string str)
	{
		std::vector<std::string> vec;

		std::string prev = NULL;
		std::string now = NULL;

		std::vector<std::string>::iterator itr;
		for (itr = vec.begin(); itr != vec.end(); itr++)
		{
			now = static_cast<std::string>(*itr);
			
			if (std::stod(now) == 0 && prev == "/")
			{
				return false;
			}

			prev = now;
		}

		return true;
	}

	//   ȣ   ȮѴ. (ex : 2*3-  ߸ )
	bool checkEndSign(std::string str)
	{
		std::string::iterator itr = str.end();

		char now;
		for (itr = str.begin(); itr != str.end(); itr++)
		{
			now = *itr;
		}

		if (now == '+' || now == '-' || now == '*' || now == '/')
		{
			return false;
		}

		return true;
	}

	// ȣ տ -  츦  ϵ Ѵ.
	std::string changeMinusBeforeBracket(std::string str)
	{
		// 2. ȣ ڿ - ִ  (ex : -(3+4) )
		// 2. 0 -  Ѵ. (ex : 0-(3+4) )
		// 2.  ش κ տ  ִ  ...3-(3+4)    ʴ´.
		// 2. ׷Ƿ n° (  n-1° - Դٸ n-2° ݵ ̾ϸ ׷  쿡 0 -  Ѵ.
		// 2. ׷ ̹ ߿ڴ ɷǷ ̷ 찡   n-2° )̰ų ( ۿ .
		// 2.  ̷  )-(̰ų Ȥ (-( 쿡 )+0-( ϰų (0-( Ѵ.
		// 2. ̷  ͺٴ string  ѹ  ٲ.

		//  :: http://dev.log.mumbi.net/296

		std::string srcString = str;
		std::string findString;
		std::string replaceString;

		std::string::size_type offset;

		offset = 0;
		findString = ")-(";
		replaceString = ")+0-(";

		while (true)
		{
			// ˻.
			offset = srcString.find(findString, offset);
			if( std::string::npos == offset )
			{
				break;
			}
			else
			{
				// ã ڿ ٲ ڿ ٲ.
				srcString.replace(offset, findString.length(), replaceString);
			}
		}

		if (VIEW_MSG)
		{
			std::cout << "ȣ  :: " << srcString << std::endl;
		}

		offset = 0;
		findString = "(-(";
		replaceString = "(0-(";

		while (true)
		{
			// ˻.
			offset = srcString.find(findString, offset);
			if( std::string::npos == offset )
			{
				break;
			}
			else
			{
				// ã ڿ ٲ ڿ ٲ.
				srcString.replace(offset, findString.length(), replaceString);
			}
		}

		if (VIEW_MSG)
		{
			std::cout << "ȣ  :: " << srcString << std::endl;
		}

		return srcString;
	}

	//  мϿ Ʈ · ȯѴ. (ex : 20*(30+10*2)+3 20,*,(,30,+,10,),+,3)
	std::vector<std::string> parseString(std::string str)
	{
		std::vector<std::string> result;

		size_t prev = 0;
	
		while (1)
		{
			size_t min = str.length();
			if (str.find("+", prev) < min)
			{
				min = str.find("+", prev);
			}
			if (str.find("-", prev) < min)
			{
				min = str.find("-", prev);
			}
			if (str.find("*", prev) < min)
			{
				min = str.find("*", prev);
			}
			if (str.find("/", prev) < min)
			{
				min = str.find("/", prev);
			}
			if (str.find("(", prev) < min)
			{
				min = str.find("(", prev);
			}
			if (str.find(")", prev) < min)
			{
				min = str.find(")", prev);
			}
	
			std::string temp = str.substr(prev, min - prev);
	
			if (str.substr(prev, min - prev) != "")
			{
				if (VIEW_MSG)
				{
					std::cout << "prev :: " << prev << " - min :: " << min << " - temp :: " << str.substr(prev, min - prev) << std::endl;
				}
				result.push_back(str.substr(prev, min - prev));
			}
			if (str.substr(min, 1) != "")
			{
				if (VIEW_MSG)
				{
					std::cout << " :: " << " - min :: " << min << " - temp :: " << str.substr(min, 1) << std::endl;
				}
				result.push_back(str.substr(min, 1));
			}
		
			prev = min + 1;
		
			if (prev >= str.length())
			{
				break;
			}
		}

		// 1.  տ - ϴ  (ex : -2+3)
		// 1. 0 -  . (ex : 0-2+3)

		if (result[0] == "-")
		{
			result.insert(result.begin(), "0");
		}

		return result;
	}

	//  ȣ ݴ ȣ ¦ ´ Ѵ.
	bool CheckBracket(std::string str)
	{
		// ϴ  ȣ Ͽ ϸ ݴ ȣ Ѵ.
		// ׸...
		//  ȣ ݴ ȣ  ƾѴ.
		//  ȣ δٸ ÷׸ 
		// ݴ ȣ δٸ ÷׸ 
		//  ÷״ 0 ǾѴ.
		// 0  ʾÿ  .

		size_t first_open = str.find_first_of("(");
		size_t first_close = str.find_first_of(")");
	
		if (VIEW_MSG)
		{
			std::cout << "first_open :: " << first_open << std::endl;
			std::cout << "first_close :: " << first_close << std::endl;
		}

		if (first_open == first_close == std::string::npos) //   ȣ ݴ ȣ ٸ  Ŀ ȣ  ùٸ ̴.
		{
			return true;
		}

		if (first_open > first_close) // տ ˻  ù  ȣ ù ݴ ȣ ڿ ִٸ   ̴.
		{
			return false;
		}

		size_t last_open = str.find_last_of("(");
		size_t last_close = str.find_last_of(")");
	
		if (VIEW_MSG)
		{
			std::cout << "last_open :: " << last_open << std::endl;
			std::cout << "last_close :: " << last_close << std::endl;
		}

		if (last_open > last_close) // տ ˻    ȣ  ݴ ȣ ڿ ִٸ   ̴.
		{
			return false;
		}

		int flag = 0;

		std::string::iterator itr;
		for (itr = str.begin(); itr != str.end(); itr++)
		{
			if (*itr == '(')
			{
				flag++;
			}
			else if (*itr == ')')
			{
				flag--;
			}
		}

		if (VIEW_MSG)
		{
			std::cout << "flag :: " << flag << std::endl;
		}

		if (flag < 0)
		{
			if (VIEW_MSG)
			{
				std::cout << "ݴ ȣ  ϴ." << std::endl;
			}
			return false;
		}
		else if (flag > 0)
		{
			if (VIEW_MSG)
			{
				std::cout << " ȣ  ϴ." << std::endl;
			}
			return false;
		}
		else
		{
			return true;
		}
	}

	//  ȯ result oper ȭ鿡 Ѵ.
	void print(std::vector<std::string> result, std::vector<std::string> oper)
	{
		std::vector<std::string>::iterator itr2;
		std::cout << "result  :: ";
		for (itr2 = result.begin(); itr2 != result.end(); itr2++)
		{
			std::cout << *itr2 << " ";
		}
		std::cout << std::endl;

		std::vector<std::string>::iterator itr3;
		std::cout << "oper  :: ";
	
		for (itr3 = oper.begin(); itr3 != oper.end(); itr3++)
		{
			std::cout << *itr3 << " ";
		}
		std::cout << std::endl;
	}

	// Է¹  ͸ ̿   Ͽ   Ѵ.
	double GetLastResult(std::vector<std::string> result)
	{
		/////////////////////////////////////////////////
		std::cout << "=========================   =========================" << std::endl;
		/////////////////////////////////////////////////

		std::stack<double> st;

		std::vector<std::string>::iterator v_itr;
		for (v_itr = result.begin(); v_itr != result.end(); v_itr++)
		{
			double first;
			double second;
		
			if (*v_itr == "+")
			{
				second = st.top();
				st.pop();
				first = st.top();
				st.pop();

				st.push(first + second);
				
				if (VIEW_MSG)
				{
					std::cout << "first :: " << first << " - second :: " << second << " - first + second :: " << first + second << std::endl;
				}
			}
			else if (*v_itr == "-")
			{
				second = st.top();
				st.pop();
				first = st.top();
				st.pop();

				st.push(first - second);

				if (VIEW_MSG)
				{
					std::cout << "first :: " << first << " - second :: " << second << " - first - second :: " << first - second << std::endl;
				}
			}
			else if (*v_itr == "*")
			{
				second = st.top();
				st.pop();
				first = st.top();
				st.pop();

				st.push(first * second);

				if (VIEW_MSG)
				{
					std::cout << "first :: " << first << " - second :: " << second << " - first * second :: " << first * second << std::endl;
				}
			}
			else if (*v_itr == "/")
			{
				second = st.top();
				st.pop();
				first = st.top();
				st.pop();

				st.push(first / second);

				if (VIEW_MSG)
				{
					std::cout << "first :: " << first << " - second :: " << second << " - first / second :: " << first / second << std::endl;
				}
			}
			else //  
			{
				double target = std::stod(*v_itr);
				st.push(target);
				//st.push(static_cast<int>(*v_itr - '0'));

				if (VIEW_MSG)
				{
					std::cout << "target :: " << target << std::endl;
				}
			}
		}

		if (VIEW_MSG)
		{
			std::cout << " :: " << st.top() << std::endl;
		}

		return st.top();
	}

	//  ȿ ڰ ԵǾ ˻Ѵ.
	bool checkCharacter(std::string str)
	{
		std::string::iterator itr = str.end();

		for (itr = str.begin(); itr != str.end(); itr++)
		{
			if (
				(*itr >= '0' && *itr <= '9') ||
				(*itr == '+' || *itr == '-' || *itr == '*' || *itr == '/' || *itr == '.' || *itr == '(' || *itr == ')')
				)
			{
			}
			else
			{
				return false;
			}
		}

		return true;
	}
};
#endif